<script lang="ts">
	import { InputVariant } from '$lib/types/input';
	import { nanoid } from 'nanoid';

	export let variant: InputVariant = InputVariant.STANDARD;
	export let label: string = '';

	$: ({ ...restProps } = $$restProps);

	let classes = 'wrapper';
	classes += ' variant-' + variant;

	const id = 'input-' + nanoid();
</script>

<div class={classes}>
	<div class="inner">
		<label for={id}>{label}</label>
		<input {id} type="text" {...restProps} />
	</div>
</div>

<style lang="scss">
	.wrapper {
		position: relative;
	}

	.wrapper .inner {
		display: flex;
		flex-direction: column;
	}

	.wrapper label {
		padding: 0.5em 0.5em 0.25em 0.5em;

		@media (min-width: 760px) {
			padding: 0.5em 1em 0.25em 1em;
		}
	}

	.wrapper input {
		border: none;
		background-color: transparent;
		font: inherit;
		color: inherit;
		padding: 0.5em;
		outline: none;
		border-radius: 4px;
		border: 2px solid var(--color-input-border);
		background-color: var(--color-input-bg);
		transition: 250ms color, 250ms background-color, 250ms border-color;
		-webkit-backdrop-filter: blur(1em);
		backdrop-filter: blur(1em);

		@media (min-width: 760px) {
			padding: 0.5em 1em;
		}

		&:hover,
		&:focus {
			border-color: var(--color-primary-500);
		}
	}

	// Variants
	.wrapper.variant-glass input {
		border-color: var(--color-input-glass-border);
		background-color: var(--color-input-glass-bg);

		&:hover,
		&:focus {
			border-color: var(--color-primary-500);
		}
	}
</style>
